/* $Id: demowindow.h,v 1.3 2001/10/26 11:14:34 murrayc Exp $ */

/* demowindow.h
 *
 * Copyright (C) 2001 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _DEMOWINDOW_H
#define _DEMOWINDOW_H

#include "gtkmm/window.h"
#include "gtkmm/notebook.h"
#include "gtkmm/box.h"

#include "gtkmm/treestore.h"
#include "gtkmm/treeview.h"
//#include "gtkmm/treeselection.h"

class DemoWindow : public Gtk::Window
{
public:
  DemoWindow();
  virtual ~DemoWindow();

protected:

  //Signal handlers:
  bool on_delete_event(GdkEventAny* event); //override

  //Member widgets:
  Gtk::Notebook m_Notebook;
  Gtk::HBox m_HBox;
  //GtkWidget *tree;
  //GtkTextTag *ta

  Glib::RefPtr<Gtk::TreeStore> m_TreeStore;
  Gtk::TreeIter* m_pTreeIter;
  Gtk::TreeView* m_pTreeView;
  Glib::RefPtr<Gtk::TreeSelection> m_refTreeSelection;
};

#endif //_DEMOWINDOW_H
