dnl $Id: class_gtkobject.m4,v 1.6 2001/10/26 11:14:36 murrayc Exp $



define(`_CLASS_GTKOBJECT',`dnl
_PUSH()
dnl
dnl  Define the args for later macros
define(`__CPPNAME__',`$1')
define(`__CNAME__',`$2')
define(`__CCAST__',`$3')
define(`__BASE__',_LOWER(__CPPNAME__))
define(`__CPPPARENT__',`$4')
define(`__CPARENT__',`$5')
define(`__PCAST__',`($5*)')

dnl
dnl ----------------------- Constructors -------------------------
dnl

dnl
dnl Declares and implements the destructor
dnl
define(`_DTOR',`dnl
_PUSH(SECTION_CC)
__CPPNAME__::~__CPPNAME__`'()
  {
    destroy_();
  }
_POP()')


_POP()
_SECTION(SECTION_CLASS2)
') dnl end of _CLASS_GTKOBJECT



dnl
dnl _END_CLASS_GTKOBJECT()
dnl   denotes the end of a class
dnl
define(`_END_CLASS_GTKOBJECT',`
_SECTION(SECTION_HEADER1)
typedef struct _`'__CNAME__ __CNAME__;
typedef struct _`'__CNAME__`'Class __CNAME__`'Class;
_SECTION(SECTION_HEADER3)
namespace Glib { __NAMESPACE__::__CPPNAME__ *wrap (__CNAME__ *o, bool take_copy = false); }
dnl
dnl
_SECTION(SECTION_PHEADER)

#include "glibmm/class.h"

__NAMESPACE_BEGIN__

_PH_CLASS_DECLARATION()

__NAMESPACE_END__

_SECTION(SECTION_SRC_GENERATED)

namespace Glib
{

__NAMESPACE__::__CPPNAME__ *wrap (__CNAME__ *o, bool take_copy /* = false */)
{
  return static_cast<__NAMESPACE__::__CPPNAME__ *> (Glib::wrap_auto ((GObject *) (o), take_copy));
}

} /* namespace Glib */

__NAMESPACE_BEGIN__


/* The *_Class implementation: */

_PCC_CLASS_IMPLEMENTATION()

Glib::Object* __CPPNAME__`'_Class::wrap_new(GObject* o, bool take_copy /* = false */)
{
  return manage(new __CPPNAME__`'((__CNAME__*)`'(o)));
}


/* The implementation: */

_CC_CLASS_IMPLEMENTATION();

__NAMESPACE_END__

dnl
dnl
dnl
dnl
_POP()

dnl The actual class, e.g. Gtk::Widget, declaration:
class __CPPNAME__`'_Class; 
_IMPORT(SECTION_CLASS1)
public:
  typedef __CPPNAME__          CppObjectType;
  typedef __CPPNAME__`'_Class    CppClassType;
  typedef __CNAME__           BaseObjectType;
  typedef __CNAME__`'Class      BaseClassType;

private:
  friend class CppClassType;
  static CppClassType `'__BASE__`'_class_;

  __CPPNAME__`'(const __CPPNAME__&);
  __CPPNAME__& operator=(const __CPPNAME__&); // not implemented

protected:
  explicit __CPPNAME__`'(__CNAME__ *castitem);

public:
  static GType get_type();
  __CNAME__* gobj()             { return (__CNAME__*)`'(gobject_); }
  const __CNAME__* gobj() const { return (__CNAME__*)`'(gobject_); }

  virtual ~__CPPNAME__`'();

_H_SIGNAL_PROXIES();

_H_VFUNCS_AND_SIGNALS()

private:
_IMPORT(SECTION_CLASS2)

')

