dnl $Id: class_shared.m4,v 1.5 2001/10/22 05:29:24 murrayc Exp $

define(`_CLASS_START',`dnl
_PUSH(SECTION_CLASS1)
')

dnl
dnl
dnl
define(`_H_VFUNCS_AND_SIGNALS',`dnl
  //Default Signal Handlers:
_IMPORT(SECTION_H_DEFAULT_SIGNAL_HANDLERS)

  //GTK+ Virtual Functions:
_IMPORT(SECTION_H_VFUNCS)
')


dnl
dnl
dnl
define(`_H_SIGNAL_PROXIES',`dnl
protected:
_IMPORT(SECTION_H_EMITPROXYSIGNALS_NAMES)

 void initialize_class(); //Call from all constructors.

public:
  //Signals:
  union
  {
  __CPPNAME__* self_`'__BASE__; //Setting this sets the obj_ member of the EmitProxySignals,
_IMPORT(SECTION_H_EMITPROXYSIGNALS);
  };
')


dnl
dnl
dnl
define(`_PH_CLASS_DECLARATION',`dnl
class __CPPNAME__`'_Class : public Glib::Class
{
public:

  typedef __CPPNAME__           CppObjectType;
  typedef __CNAME__           BaseObjectType;
ifdef(`__BOOL_NO_DERIVED_CLASS__',`dnl
',`dnl
  typedef __CNAME__`'Class      BaseClassType;
  typedef __CPPPARENT__`'_Class     CppClassParent;
  typedef __CPARENT__`'Class      BaseClassParent;
')dnl

ifdef(`__BOOL_NO_DERIVED_CLASS__',`dnl
',`dnl
  static void class_init_function(BaseClassType *p);
  static void object_init_function(BaseObjectType *o);
')dnl

  GType get_type();

  // Hook for translating API
  static Glib::Object* wrap_new(GObject*, bool take_copy = false);

  //Callbacks (default signal handlers):
  //These will call the *_impl member methods, which will then call the existing default signal callbacks, if any.
  //You could prevent the original default signal handlers being called by overriding the *_impl method.
_IMPORT(SECTION_PH_DEFAULT_SIGNAL_HANDLERS)

  //Callbacks (virtual functions):
_IMPORT(SECTION_PH_VFUNCS)
};
')


dnl
dnl
dnl
define(`_PCC_CLASS_IMPLEMENTATION',`dnl
GType __CPPNAME__`'_Class::get_type()
  {
ifdef(`__BOOL_NO_DERIVED_CLASS__',`dnl
    gtype_ = _LOWER(__CCAST__)_get_type(); //The actual struct definition is hidden, so we can not derive one.
',`dnl
    if (!gtype_) //Create the GType if necessary.
      {
        //Make sure that the C type has been created:
        CppClassParent::CppObjectType::get_type();

        //Create a derived C type.
        //These init funcs will, in turn, call the init functions in the base C type.
        GTypeInfo info =
          {
            sizeof(BaseClassType), /* class_size */
            (GBaseInitFunc) 0, /* base_init */
            (GBaseFinalizeFunc) 0, /* base_finalize */
            (GClassInitFunc) class_init_function, /* class_init */
            0, /* class_finalize */
            0, /* class_data */
            sizeof (BaseObjectType), /* instance_size */
            0, /* n_preallocs */
            (GInstanceInitFunc) object_init_function /* instance_init */
          };

        gtype_ = g_type_register_static(_LOWER(__CCAST__)_get_type(), "__MODULE__`'__`'__CPPNAME__", &info, GTypeFlags(0));
      }
')dnl
    return gtype_;
  }
ifdef(`__BOOL_NO_DERIVED_CLASS__',`dnl
',`dnl
void __CPPNAME__`'_Class::class_init_function(__CNAME__`'Class *klass)
  {
    CppClassParent::class_init_function((BaseClassParent*)klass);
   _IMPORT(SECTION_PCC_CLASS_INIT_VFUNCS)
   _IMPORT(SECTION_PCC_CLASS_INIT_DEFAULT_SIGNAL_HANDLERS)
  }

void __CPPNAME__`'_Class::object_init_function(__CNAME__ *)
  {
dnl _IMPORT(SECTION_PCC_OBJECT_INIT)
  }
')dnl

_IMPORT(SECTION_PCC_VFUNCS)

_IMPORT(SECTION_PCC_DEFAULT_SIGNAL_HANDLERS)
')



dnl
dnl
dnl
define(`_CC_CLASS_IMPLEMENTATION',`dnl
__CPPNAME__::CppClassType __CPPNAME__::`'__BASE__`'_class_; //Initialize static member.

GType __CPPNAME__::get_type()
  {
    return `'__BASE__`'_class_.get_type();
  }

void __CPPNAME__::initialize_class()
{
  //Call this from every constructor.
  //You can call it as many times as you like.

  //Set one member of the union,
  //to set the obj_ member in all of the EmitProxySignal members.
  self_`'__BASE__ = this;
}

_IMPORT(SECTION_CC_EMITPROXYSIGNALS_NAMES_INIT)

_IMPORT(SECTION_CC)


_IMPORT(SECTION_CC_DEFAULT_SIGNAL_HANDLERS)

_IMPORT(SECTION_CC_VFUNCS)
')

