dnl $Id: convert.m4,v 1.6 2001/10/22 07:10:36 murrayc Exp $

#
#  Define a hashing for names
#
define(`__HASH',`__`'translit(`$*',`ABCDEFGHIJKLMNOPQRSTUVWXYZ<>[]&*, ',`abcdefghijklmnopqrstuvwxyzVBNMRSC_')`'')
define(`__EQUIV',`ifdef(EV`'__HASH(`$1'),EV`'__HASH(`$1'),`$1')')

define(`__HASH2',`dnl
pushdef(`__E1',__EQUIV(`$1'))pushdef(`__E2',__EQUIV(`$2'))dnl
ifelse(__E1,__E2,`__EQ',__HASH(__E1)`'__HASH(__E2))`'dnl
popdef(`__E1')popdef(`__E2')`'')

define(`CF__EQ',`$3')

#
#  _CONVERT(ctype, cpptype, name, wrap_line)
#    Print the conversion from ctype to cpptype
define(`_CONVERT',`dnl
pushdef(`__COV',`CF`'__HASH2(`$1',`$2')')dnl
ifdef(__COV,`indir(__COV,`$1',`$2',`$3')',`
errprint(`No conversion from $1 to $2 defined (line: $4, parameter name: $3)
')')`'dnl
`'dnl
')


#
#  Functions for populating the tables.
#
define(`_CONVERSION',`
ifelse(`$3',,,`define(CF`'__HASH2(`$1',`$2'),`$3')')
')

define(`_EQUAL',`define(EV`'__HASH(`$1'),`$2')')

/*******************************************************************/


# e.g. Glib::RefPtr<Gdk::Something> to GdkSomething*
define(`__CONVERT_REFPTR_TO_P',`$`'3->gobj()')

include(convert_gtk.m4)
include(convert_pango.m4)
include(convert_gdk.m4)
include(convert_atk.m4)