_EQUAL(gint8[],gint8*)

_CONVERSION(`GdkModifierType&',`GdkModifierType*',`&$3',`*$3')
_CONVERSION(`GdkWMDecoration&',`GdkWMDecoration*',`&$3',`*$3')
_CONVERSION(`GdkRectangle&',`GdkRectangle*',`&$3',`*$3')

# Ref (gdkmm) -> Ptr (gtk+)
_CONVERSION(`Color&',`GdkColor*',__FR2P)
_CONVERSION(`Rectangle&',`GdkRectangle*',__FR2P)
_CONVERSION(`Gdk::Rectangle&',`GdkRectangle*',__FR2P)
_CONVERSION(`Font&',`GdkFont*',__FR2P)
_CONVERSION(`Region&',`GdkRegion*',__FR2P)

_CONVERSION(`const Glib::RefPtr<Gdk::Colormap>&',`GdkColormap*',__CONVERT_REFPTR_TO_P)
_CONVERSION(`const Glib::RefPtr<Gdk::Pixmap>&',`GdkPixmap*',__CONVERT_REFPTR_TO_P)
_CONVERSION(`const Glib::RefPtr<Gdk::Window>&',`GdkWindow*',__CONVERT_REFPTR_TO_P)
_CONVERSION(`const Glib::RefPtr<Window>&',`GdkWindow*',__CONVERT_REFPTR_TO_P)
_CONVERSION(`const Glib::RefPtr<Pixmap>&',`GdkPixmap*',__CONVERT_REFPTR_TO_P)
_CONVERSION(`const Glib::RefPtr<Bitmap>&',`GdkBitmap*',__CONVERT_REFPTR_TO_P)
_CONVERSION(`const Glib::RefPtr<Gdk::Bitmap>&',`GdkBitmap*',__CONVERT_REFPTR_TO_P)
_CONVERSION(`const Glib::RefPtr<Colormap>&',`GdkColormap*',__CONVERT_REFPTR_TO_P)
_CONVERSION(`const Glib::RefPtr<GC>&',`GdkGC*',__CONVERT_REFPTR_TO_P)
_CONVERSION(`const Glib::RefPtr<Gdk::GC>&',`GdkGC*',__CONVERT_REFPTR_TO_P)
_CONVERSION(`const Glib::RefPtr<Drawable>&',`GdkDrawable*',__CONVERT_REFPTR_TO_P)
_CONVERSION(`const Glib::RefPtr<Image>&',`GdkImage*',__CONVERT_REFPTR_TO_P)
_CONVERSION(`const Glib::RefPtr<Gdk::Image>&',`GdkImage*',__CONVERT_REFPTR_TO_P)
_CONVERSION(`const Glib::RefPtr<Pixbuf>&',`GdkPixbuf*',__CONVERT_REFPTR_TO_P)
_CONVERSION(`const Glib::RefPtr<Gdk::Pixbuf>&',`GdkPixbuf*',__CONVERT_REFPTR_TO_P)
_CONVERSION(`const Glib::RefPtr<Gdk::PixbufAnimation>&',`GdkPixbufAnimation*',__CONVERT_REFPTR_TO_P)

_CONVERSION(GdkFont*,const Gdk::Font&,`const_cast<$1>($3.gobj())')
_CONVERSION(GdkColor*,const Gdk::Color&,`const_cast<$1>($3.gobj())')

define(`__CFR2P',`const_cast<$`'2>($`'3.gobj())')
_CONVERSION(const Font&,GdkFont*,__CFR2P)
_CONVERSION(const Gdk::Color&,GdkColor*,__CFR2P)
_CONVERSION(const Color&,GdkColor*,__CFR2P)
_CONVERSION(const Gdk::Rectangle&,GdkRectangle*,__CFR2P)
_CONVERSION(const Rectangle&,GdkRectangle*,__CFR2P)
_CONVERSION(const Geometry&,GdkGeometry*,__CFR2P)

dnl TODO: Should this always be a copy?
_CONVERSION(const Cursor&,GdkCursor*,($3).gobj_copy())


_CONVERSION(const Glib::RefPtr<const Gdk::Pixmap>&,GdkPixmap*,__CONVERT_CONST_REFPTR_TO_P)
_CONVERSION(const Glib::RefPtr<const Gdk::Window>&,GdkWindow*,__CONVERT_CONST_REFPTR_TO_P)
_CONVERSION(const Glib::RefPtr<const Gdk::Colormap>&,GdkColormap*,__CONVERT_CONST_REFPTR_TO_P)
_CONVERSION(const Glib::RefPtr<const Gdk::Visual>&,GdkVisual*,__CONVERT_CONST_REFPTR_TO_P)
_CONVERSION(const Glib::RefPtr<const Gdk::Bitmap>&,GdkBitmap*,__CONVERT_CONST_REFPTR_TO_P)
_CONVERSION(const Glib::RefPtr<const Gdk::Image>&,GdkImage*,__CONVERT_CONST_REFPTR_TO_P)


_CONVERSION(`GdkWindow*',`Glib::RefPtr<Window>', Window::wrap_specific_type($3))
_CONVERSION(`GdkWindow*',`Glib::RefPtr<Gdk::Window>', Gdk::Window::wrap_specific_type($3))
_CONVERSION(`GdkPixmap*',`Glib::RefPtr<Pixmap>',Pixmap::wrap_specific_type($3))
_CONVERSION(`GdkPixmap*',`Glib::RefPtr<Gdk::Pixmap>',Gdk::Pixmap::wrap_specific_type($3))
_CONVERSION(`GdkColormap*',`Glib::RefPtr<Colormap>',Glib::wrap($3))
_CONVERSION(`GdkColormap*',`Glib::RefPtr<Gdk::Colormap>',Glib::wrap($3))
_CONVERSION(`GdkVisual*',`Glib::RefPtr<Gdk::Visual>', Gdk::Visual::wrap_specific_type($3))
_CONVERSION(`GdkVisual*',`Glib::RefPtr<Visual>', Gdk::Visual::wrap_specific_type($3))
_CONVERSION(`GdkImage*',`Glib::RefPtr<Image>', Glib::wrap($3))
_CONVERSION(`GdkPixbuf*',`Glib::RefPtr<Pixbuf>', Glib::wrap($3))
_CONVERSION(`GdkPixbuf*',`Glib::RefPtr<Gdk::Pixbuf>', Glib::wrap($3))

dnl
dnl
dnl #
dnl # Gdk types
dnl #
dnl
dnl dnl Gdk::Drag_Context,Gdk::Image,Gdk::Bitmap,Gdk::Color,Gdk::Colormap,Gdk::Pixmap,Gdk::Window,dnl
dnl dnl Gdk::Visual,Gdk::Rectangle
dnl
_CONVERSION(GdkWindow*,Gdk::Window,`($3)')
_CONVERSION(GdkVisual*,Gdk::Visual,`($3)')
_CONVERSION(GdkColormap*,Gdk::Colormap,`($3)')
_CONVERSION(Gdk::Font, GdkFont*,`$3',`$3.gobj()')

_CONVERSION(GdkFont*, Gdk::Font, `Gdk::Font($3)')
_CONVERSION(GdkEvent*, Event, `Event($3)')
_CONVERSION(GdkRegion*, Region, `Region($3)')

dnl
dnl _CONVERSION(GdkDragContext*,Gdk::Drag_Context&,`$3.gobj()',`$3')
dnl _CONVERSION(GdkWindow*,Gdk::Window&,`$3.gobj()',`$3')
_CONVERSION(GdkPixmap*,Gdk::Pixmap&,`$3.gobj()',`$3')
_CONVERSION(GdkBitmap*,Gdk::Bitmap&,`$3.gobj()',`$3')
dnl _CONVERSION(GdkColormap*,Gdk::Colormap&,`$3.gobj()',`$3')
dnl
dnl _CONVERSION(GdkWindow*,const Gdk::Window&,`const_cast<$1>($3.gobj())')
dnl _CONVERSION(GdkColormap*,const Gdk::Colormap&,`const_cast<$1>($3.gobj())')
dnl _CONVERSION(GdkVisual*,const Gdk::Visual&,`const_cast<$1>($3.gobj())')
dnl _CONVERSION(GdkRectangle*,const Gdk::Rectangle&,`const_cast<$1>($3.gobj())')
dnl
dnl _CONVERSION(GdkPixmap*,const Gdk::Pixmap&,`const_cast<$1>($3.gobj())')
dnl _CONVERSION(const GdkPixmap*,const Gdk::Pixmap&,`$3.gobj()')
dnl
dnl _CONVERSION(GdkImlibImage*,const Gdk::ImLib::Image&,`const_cast<$1>($3.gobj())')
dnl