dnl $Id: ctor.m4,v 1.2 2001/10/26 11:14:36 murrayc Exp $

dnl
dnl
dnl  Code generation sections for making a constructor.
dnl
dnl

dnl
dnl Declares and implements the default constructor
dnl
define(`_CTOR_DEFAULT',`dnl
__CPPNAME__`'();
_PUSH(SECTION_CC)
__CPPNAME__::__CPPNAME__`'()
  :     __CPPPARENT__`'(__PCAST__`'(g_object_new(get_type(),0)))
{
   initialize_class(); //Needed for EmitProxySignal objects.
}

_POP()
')


dnl
dnl Implements the cast constructor
dnl
define(`_CTOR_CAST',`dnl
_PUSH(SECTION_CC)
__CPPNAME__::__CPPNAME__`'(__CNAME__ *castitem)
  :     __CPPPARENT__`'(__PCAST__`'(castitem))
{
  initialize_class(); //Needed for EmitProxySignal objects.
}

_POP()')


dnl
dnl Constructors for _new functions.
dnl               $1      $2    $3     $4
dnl  _CTOR_IMPL(cppname,cname,cppargs,c_varargs)
define(`_CTOR_IMPL',`dnl
_PUSH(SECTION_CC)
__CPPNAME__::$1`'($3)
: __CPPPARENT__`'(__PCAST__`'( g_object_new( get_type() `'ifelse(`$4',,,`, $4')`', 0 ) ))
{
  initialize_class(); //Needed for EmitProxySignal objects.
}

_POP()')

