#include <gtkmm/main.h>
#include <gtkmm/window.h>
#include "tictactoe.h"

void
win (TicTacToe *ttt)
{
  g_print ("Yay!\n");
  ttt-> clear();
}

bool on_win_delete_event (GdkEventAny*)
{
    Gtk::Main::quit();
    return false;
}

int 
main (int argc, char *argv[])
{
  Gtk::Window *window;
  TicTacToe *ttt;
  
  Gtk::Main m(argc, argv);

  ttt = manage( new TicTacToe () );
  ttt-> tictactoe.connect ( bind (slot (&win), ttt) );

  window = manage( new Gtk::Window () );
  window-> set_title ("Tic-Tac-Toe");
  window-> signal_delete_event.connect (&on_win_delete_event);
  window-> set_border_width (10);
  window-> add (*ttt);
  window-> show_all ();
  
  Gtk::Main::run ();
  
  return 0;
}
