
#include "types.h"

namespace Gdk {

Rectangle::~Rectangle() {}
Segment::~Segment() {}
Point::~Point() {}



void Points::a_alloc(size_t size)
  {
    points_ = new GdkPoint[size];
    owned_ = true;
  }

Points::Points(GdkPoint * points, int size)
  {
    a_dup((GdkPoint*)points, (GdkPoint*)(&points[size]));
  }

Points::Points(Point * points, int size)
  {
    a_dup((GdkPoint*)points, (GdkPoint*)(&points[size]));
  }

Points::~Points ()
  {
    if(owned_ == true)
      delete points_;
  }

} /* namespace Gdk */

