dnl
dnl --------------------------- Accessors ----------------------------
dnl


dnl Creates accessors for simple types:
define(`_MEMBER',`dnl
$3 get_$1() const;
_PUSH(SECTION_CC)
$3 __CPPNAME__::get_$1() const
{
  return _CONVERT($4,$3,`gobj()->$2');
}

_POP()')

dnl Creates accessors for GObject-derived types that must be ref()ed.
define(`_MEMBER_GOBJECT',`dnl
$3 get_$1() const;
_PUSH(SECTION_CC)
$3 __CPPNAME__::get_$1() const
{
  $3 refPtr = _CONVERT($4,$3,`gobj()->$2');
  refPtr->reference(); //We could use the bool with Glib::wrap(), but we want to share the m4 type-conversion map.
  return refPtr;
}

_POP()')
