dnl
dnl _VFUNC_PH(gtkname, crettype, cargs and names)
dnl Create a callback and set it in our derived G*Class.
dnl
define(`_VFUNC_PH',`dnl
_PUSH(SECTION_PCC_CLASS_INIT_VFUNCS)
    klass->$1 = `&'$1_vfunc_callback;
_SECTION(SECTION_PH_VFUNCS)
  static $2 $1_vfunc_callback($3);
_POP()')


#                        $1      $2       $3        $4
# _VFUNC_PCC(cppname,gtkname,cpprettype,crettype,
#                        $5                $6          $7            $8
#                  `<cargs and names>',`<cnames>',`<cpparg names>',firstarg)
#
define(`_VFUNC_PCC',`dnl
_PUSH(SECTION_PCC_VFUNCS)
$4 __CPPNAME__`'_Class::$2_vfunc_callback($5)
  {
    CppObjectType *obj=
dnl Do not change the line below, both casts are necessary
      static_cast<CppObjectType*>(static_cast<Gtk::Object*>(
        gtk_object_get_data_by_id((GtkObject*)$8, Glib::quark_)));

_IMPORT(SECTION_CHECK)
ifelse($4,void,`dnl
    if (obj)
      obj->$1($7);
    else
      {
        BaseClassType* base = static_cast<BaseClassType*>( g_type_class_peek_parent(G_OBJECT_GET_CLASS($8)) );

        if (base->$2)
          (base->$2)($6);
      }
',`dnl
    if (obj)
      return _CONVERT($4,$3,`obj->$1`'($7)');
    BaseClassType* base=
      static_cast<BaseClassType*>(
        g_type_class_peek_parent(G_OBJECT_GET_CLASS($8)));
    if (base->$2)
      return (base->$2)($6);

    return 0;
')
  }

_POP()')


#                    $1      $2       $3
# _VFUNC_H(signame,rettype,`<cppargs>')
#
define(`_VFUNC_H',`dnl
_PUSH(SECTION_H_VFUNCS)
  virtual $2 $1($3);
_POP()')

#                    $1      $2       $3     $4       $5          $6
# _VFUNC_CC(signame,gtkname,rettype,crettype,`<cppargs>',`<carg_names>')
#
define(`_VFUNC_CC',`dnl
_PUSH(SECTION_CC_VFUNCS)
$3 __NAMESPACE__::__CPPNAME__::$1($5)
  {
    BaseClassType* base=
      static_cast<BaseClassType*>(
        g_type_class_peek_parent(G_OBJECT_GET_CLASS(gobject_)));
    if (base->$2)
ifelse($3,void,`dnl
      (base->$2)(gobj()`'ifelse(`$6',,,`,')$6);
',`dnl
      return _CONVERT($3,$4,(base->$2)(gobj()`'ifelse(`$6',,,`,')$6));
    return 0;
')
  }

_POP()')


